Index: django/core/management/commands/importcldr.py
===================================================================
--- django/core/management/commands/importcldr.py	(.../trunk)	(revision 0)
+++ django/core/management/commands/importcldr.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -0,0 +1,221 @@
+import sys
+import os
+import re
+from optparse import make_option, OptionParser
+
+from django.core.management.base import LabelCommand, CommandError
+
+try:
+    from lxml import etree
+except ImportError:
+    raise CommandError('You need to install `python-lxml` to run this script')
+
+FORMATS_FILE_NAME = 'formats.py'
+FORMATS_FILE_HEADER = '''# -*- encoding: utf-8 -*-
+# This file is distributed under the same license as the Django package.
+#
+
+'''
+
+def quote(nodes, name,  locale, previous):
+    if len(nodes):
+        return "'%s'" % unicode(nodes[0].text).replace("'", "\\'")
+    else:
+        return None
+
+def convert_time(nodes, name,  locale, previous):
+    SPECIAL_CHARS = ('a', 'A', 'b', 'B', 'd', 'D', 'f', 'F', 'g', 'G', 'h',
+        'H', 'i', 'I', 'j', 'l', 'L', 'm', 'M', 'n', 'N', 'O', 'P', 'r',
+        's', 'S', 't', 'T', 'U', 'w', 'W', 'y', 'Y', 'z', 'Z')
+    FORMAT_STR_MAP = ( # not using a dict, because we have to apply formats in order
+        ('dd', 'd'),
+        ('d', 'j'),
+        ('MMMM', 'F'),
+        ('MMM', 'M'),
+        ('MM', 'm'),
+        ('M', 'n'),
+        ('yyyy', 'Y'),
+        ('yy', 'y'),
+        ('y', 'Y'),
+        ('hh', 'h'),
+        ('h', 'g'),
+        ('HH', 'H'),
+        ('H', 'G'),
+        ('mm', 'i'),
+        ('ss', 's'),
+        ('a', 'A'),
+        ('LLLL', 'F'),
+    )
+    if len(nodes):
+        original = nodes[0].text
+        result = ''
+        for cnt, segment in enumerate(original.split("'")):
+            if cnt % 2:
+                for char in SPECIAL_CHARS:
+                    segment = segment.replace(char, '\\%s' % char)
+                result += segment
+            else:
+                while segment:
+                    found = False
+                    for src, dst in FORMAT_STR_MAP:
+                        if segment[0:len(src)] == src:
+                            result += dst
+                            segment = segment[len(src):]
+                            found = True
+                            break
+                    if not found:
+                        result += segment[0]
+                        segment = segment[1:]
+
+        return "'%s'" % result
+    else:
+        return None
+
+def datetime(nodes, name, locale, previous):
+    result = None
+    if len(nodes) and 'DATE_FORMAT' in previous and 'TIME_FORMAT' in previous:
+        result = nodes[0].text
+        result = result.replace('{0}', previous['TIME_FORMAT'][1:-1])
+        if name == 'SHORT_DATETIME_FORMAT' and 'SHORT_DATE_FORMAT' in previous:
+            result = result.replace('{1}', previous['SHORT_DATE_FORMAT'][1:-1])
+        else:
+            result = result.replace('{1}', previous['DATE_FORMAT'][1:-1])
+    if result:
+        return "'%s'" % result
+    else:
+        return None
+
+FORMATS_MAP = [
+    {
+        'name': 'DATE_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateFormats/dateFormatLength[@type='long']/dateFormat/pattern",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'TIME_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/timeFormats/timeFormatLength[@type='medium']/timeFormat/pattern",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'DATETIME_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/dateTimeFormatLength[@type='long']/dateTimeFormat/pattern",
+        'conversion': datetime,
+    },
+    {
+        'name': 'YEAR_MONTH_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/availableFormats/dateFormatItem[@id='yMMMM']",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'MONTH_DAY_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/availableFormats/dateFormatItem[@id='MMMMd']",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'SHORT_DATE_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateFormats/dateFormatLength[@type='medium']/dateFormat/pattern",
+        'conversion': convert_time,
+    },
+    {
+        'name': 'SHORT_DATETIME_FORMAT',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/dates/calendars/calendar[@type='gregorian']/dateTimeFormats/dateTimeFormatLength[@type='short']/dateTimeFormat/pattern",
+        'conversion': datetime,
+    },
+    {'name': 'FIRST_DAY_OF_WEEK'},
+    {'name': 'DATE_INPUT_FORMATS'},
+    {'name': 'TIME_INPUT_FORMATS'},
+    {'name': 'DATETIME_INPUT_FORMATS'},
+    {
+        'name': 'DECIMAL_SEPARATOR',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/numbers/symbols/decimal",
+        'conversion': quote,
+    },
+    {
+        'name': 'THOUSAND_SEPARATOR',
+        'file': os.path.join('common', 'main', '%(locale)s.xml'),
+        'pattern': "/ldml/numbers/symbols/group",
+        'conversion': quote,
+    },
+    {'name': 'NUMBER_GROUPING'},
+]
+"""
+"""
+
+def get_locales(django_locale_dir, locale=None):
+    if locale:
+        yield locale
+    else:
+        locale_re = re.compile('[a-z]{2}(_[A-Z]{2})?')
+        for locale in os.listdir(django_locale_dir):
+            if locale_re.match(locale):
+                yield locale
+
+def import_cldr(cldr_dir, locale=None, overwrite=False):
+    """
+    For every locale defined in Django, get from the CLDR locale file all
+    settings defined in output_structure, and write the result to the 
+    locale directories on Django.
+    """
+    if not os.path.isdir(cldr_dir):
+        raise Exception, "Specified CLDR directory '%s' does not exist" % cldr_dir
+
+    import django
+    django_locale_dir = os.path.join(os.path.dirname(django.__file__), 'conf', 'locale')
+
+    for locale in get_locales(django_locale_dir, locale):
+        output_filename = os.path.join(django_locale_dir, locale, FORMATS_FILE_NAME)
+        if os.path.isfile(output_filename) and not overwrite:
+            print "'%s' locale already exists. Skipping" % locale
+        else:
+            result = {}
+            output_file = open(output_filename, 'w')
+            output_file.write(FORMATS_FILE_HEADER)
+            for format in FORMATS_MAP:
+                if 'file' in format:
+                    cldr_file = os.path.join(cldr_dir, format['file'] % dict(locale=locale))
+                    tree = etree.parse(cldr_file) # TODO: error control
+                    try:
+                        original_value = tree.xpath(format['pattern'])
+                    except IndexError:
+                        output_file.write('# %s = \n' % (format['name']))
+                    else:
+                        value = format['conversion'](original_value, format['name'], locale, result)
+                        if value:
+                            output_file.write('%s = %s\n' % (format['name'], value.encode('utf8')))
+                            result[format['name']] = value
+                        else:
+                            output_file.write('# %s = \n' % (format['name']))
+                else:
+                    output_file.write('# %s = \n' % (format['name']))
+            output_file.close()
+
+            init_filename = os.path.join(django_locale_dir, locale, '__init__.py')
+            open(init_filename, 'a').close()
+
+class Command(LabelCommand):
+    option_list = LabelCommand.option_list + (
+        make_option('--locale', '-l', dest='locale',
+            help='The locale to process. Default is to process all.'),
+    ) + (
+        make_option('--overwite', '-o', action='store_true', dest='overwrite',
+            help='Wheter to overwrite format definitions of locales that already have one.'),
+    )
+    help = 'Creates format definition files for locales, importing data from the CLDR.'
+    args = '[cldrpath]'
+    label = 'CLDR path'
+    requires_model_validation = False
+    can_import_settings = False
+
+    def handle_label(self, cldrpath, **options):
+        locale = options.get('locale')
+        overwrite = options.get('overwrite')
+        import_cldr(cldrpath, locale, overwrite)
+
Index: django/views/i18n.py
===================================================================
--- django/views/i18n.py	(.../trunk)	(revision 11464)
+++ django/views/i18n.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -3,6 +3,7 @@
 from django.utils import importlib
 from django.utils.translation import check_for_language, activate, to_locale, get_language
 from django.utils.text import javascript_quote
+from django.utils.formats import project_formats_module, django_formats_module
 import os
 import gettext as gettext_module
 
@@ -32,6 +33,25 @@
                 response.set_cookie(settings.LANGUAGE_COOKIE_NAME, lang_code)
     return response
 
+def get_formats():
+    """
+    Returns an iterator over all formats in formats file
+    """
+    FORMAT_SETTINGS = ('DATE_FORMAT', 'DATETIME_FORMAT', 'TIME_FORMAT',
+        'YEAR_MONTH_FORMAT', 'MONTH_DAY_FORMAT', 'SHORT_DATE_FORMAT',
+        'SHORT_DATETIME_FORMAT', 'FIRST_DAY_OF_WEEK', 'DECIMAL_SEPARATOR',
+        'THOUSAND_SEPARATOR', 'NUMBER_GROUPING')
+
+    result = {}
+    for module in (settings, django_formats_module(), project_formats_module()):
+        if module:
+            for attr in FORMAT_SETTINGS:
+                try:
+                    result[attr] = getattr(module, attr)
+                except AttributeError:
+                    pass
+    return result
+    
 NullSource = """
 /* gettext identity library */
 
@@ -185,10 +205,13 @@
         else:
             raise TypeError, k
     csrc.sort()
-    for k,v in pdict.items():
+    for k, v in pdict.items():
         src.append("catalog['%s'] = [%s];\n" % (javascript_quote(k), ','.join(["''"]*(v+1))))
+    for k, v in get_formats().items():
+        src.append("catalog['%s'] = '%s';\n" % (javascript_quote(k), javascript_quote(unicode(v))))
     src.extend(csrc)
     src.append(LibFoot)
     src.append(InterPolate)
     src = ''.join(src)
     return http.HttpResponse(src, 'text/javascript')
+
Index: django/utils/numberformat.py
===================================================================
--- django/utils/numberformat.py	(.../trunk)	(revision 0)
+++ django/utils/numberformat.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -0,0 +1,40 @@
+from django.conf import settings
+
+def format(number, decimal_sep, decimal_pos, grouping=0, thousand_sep=''):
+    """
+    Gets a number (as a number or string), and returns it as a string,
+    using formats definied as arguments:
+     * decimal_sep: Decimal separator symbol (for example ".")
+     * decimal_pos: Number of decimal positions
+     * grouping: Number of digits in every group limited by thousand separator
+     * thousand_sep: Thousand separator symbol (for example ",")
+    """
+    # sign
+    if number < 0:
+        sign = '-'
+    else:
+        sign = ''
+    # decimal part
+    str_number = unicode(number)
+    if str_number[0] == '-':
+        str_number = str_number[1:]
+    if '.' in str_number:
+        int_part, dec_part = str_number.split('.')
+        if decimal_pos:
+            dec_part = dec_part[:decimal_pos]
+    else:
+        int_part, dec_part = str_number, ''
+    if decimal_pos:
+        dec_part = dec_part + ('0' * (decimal_pos - len(dec_part)))
+    if dec_part: dec_part = decimal_sep + dec_part
+    # grouping
+    if settings.USE_THOUSAND_SEPARATOR and grouping:
+        int_part_gd = ''
+        for cnt, digit in enumerate(int_part[::-1]):
+            if cnt and not cnt % grouping:
+                int_part_gd += thousand_sep
+            int_part_gd += digit
+        int_part = int_part_gd[::-1]
+
+    return sign + int_part + dec_part
+
Index: django/utils/translation/trans_real.py
===================================================================
--- django/utils/translation/trans_real.py	(.../trunk)	(revision 11464)
+++ django/utils/translation/trans_real.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -266,15 +266,16 @@
     translation object to use. If no current translation is activated, the
     message will be run through the default translation object.
     """
+    eol_message = message.replace('\r\n', '\n').replace('\r', '\n')
     global _default, _active
     t = _active.get(currentThread(), None)
     if t is not None:
-        result = getattr(t, translation_function)(message)
+        result = getattr(t, translation_function)(eol_message)
     else:
         if _default is None:
             from django.conf import settings
             _default = translation(settings.LANGUAGE_CODE)
-        result = getattr(_default, translation_function)(message)
+        result = getattr(_default, translation_function)(eol_message)
     if isinstance(message, SafeData):
         return mark_safe(result)
     return result
@@ -389,39 +390,6 @@
 
     return settings.LANGUAGE_CODE
 
-def get_date_formats():
-    """
-    Checks whether translation files provide a translation for some technical
-    message ID to store date and time formats. If it doesn't contain one, the
-    formats provided in the settings will be used.
-    """
-    from django.conf import settings
-    date_format = ugettext('DATE_FORMAT')
-    datetime_format = ugettext('DATETIME_FORMAT')
-    time_format = ugettext('TIME_FORMAT')
-    if date_format == 'DATE_FORMAT':
-        date_format = settings.DATE_FORMAT
-    if datetime_format == 'DATETIME_FORMAT':
-        datetime_format = settings.DATETIME_FORMAT
-    if time_format == 'TIME_FORMAT':
-        time_format = settings.TIME_FORMAT
-    return date_format, datetime_format, time_format
-
-def get_partial_date_formats():
-    """
-    Checks whether translation files provide a translation for some technical
-    message ID to store partial date formats. If it doesn't contain one, the
-    formats provided in the settings will be used.
-    """
-    from django.conf import settings
-    year_month_format = ugettext('YEAR_MONTH_FORMAT')
-    month_day_format = ugettext('MONTH_DAY_FORMAT')
-    if year_month_format == 'YEAR_MONTH_FORMAT':
-        year_month_format = settings.YEAR_MONTH_FORMAT
-    if month_day_format == 'MONTH_DAY_FORMAT':
-        month_day_format = settings.MONTH_DAY_FORMAT
-    return year_month_format, month_day_format
-
 dot_re = re.compile(r'\S')
 def blankout(src, char):
     """
@@ -537,3 +505,42 @@
         result.append((lang, priority))
     result.sort(lambda x, y: -cmp(x[1], y[1]))
     return result
+
+# get_date_formats and get_partial_date_formats aren't used anymore from django
+# itself, and are kept for backward compatibility.
+# Note that it's also important to keep format names maked for translation, so
+# for compatibility we still want to have formats on translation catalogs. That
+# makes template code like {{ my_date|date:_('DATE_FORMAT') }} go on working
+def get_date_formats():
+    """
+    Checks whether translation files provide a translation for some technical
+    message ID to store date and time formats. If it doesn't contain one, the
+    formats provided in the settings will be used.
+    """
+    from django.conf import settings
+    date_format = ugettext('DATE_FORMAT')
+    datetime_format = ugettext('DATETIME_FORMAT')
+    time_format = ugettext('TIME_FORMAT')
+    if date_format == 'DATE_FORMAT':
+        date_format = settings.DATE_FORMAT
+    if datetime_format == 'DATETIME_FORMAT':
+        datetime_format = settings.DATETIME_FORMAT
+    if time_format == 'TIME_FORMAT':
+        time_format = settings.TIME_FORMAT
+    return date_format, datetime_format, time_format
+
+def get_partial_date_formats():
+    """
+    Checks whether translation files provide a translation for some technical
+    message ID to store partial date formats. If it doesn't contain one, the
+    formats provided in the settings will be used.
+    """
+    from django.conf import settings
+    year_month_format = ugettext('YEAR_MONTH_FORMAT')
+    month_day_format = ugettext('MONTH_DAY_FORMAT')
+    if year_month_format == 'YEAR_MONTH_FORMAT':
+        year_month_format = settings.YEAR_MONTH_FORMAT
+    if month_day_format == 'MONTH_DAY_FORMAT':
+        month_day_format = settings.MONTH_DAY_FORMAT
+    return year_month_format, month_day_format
+
Index: django/utils/translation/trans_null.py
===================================================================
--- django/utils/translation/trans_null.py	(.../trunk)	(revision 11464)
+++ django/utils/translation/trans_null.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -18,10 +18,10 @@
 deactivate = deactivate_all = lambda: None
 get_language = lambda: settings.LANGUAGE_CODE
 get_language_bidi = lambda: settings.LANGUAGE_CODE in settings.LANGUAGES_BIDI
-get_date_formats = lambda: (settings.DATE_FORMAT, settings.DATETIME_FORMAT, settings.TIME_FORMAT)
-get_partial_date_formats = lambda: (settings.YEAR_MONTH_FORMAT, settings.MONTH_DAY_FORMAT)
 check_for_language = lambda x: True
 
+# date formats shouldn't be used using gettext anymore. This
+# is kept for backward compatibility
 TECHNICAL_ID_MAP = {
     "DATE_WITH_TIME_FULL": settings.DATETIME_FORMAT,
     "DATE_FORMAT": settings.DATE_FORMAT,
@@ -51,3 +51,8 @@
 
 def get_language_from_request(request):
     return settings.LANGUAGE_CODE
+
+# get_date_formats and get_partial_date_formats aren't used anymore from django
+# itself, and are kept for backward compatibility.
+get_date_formats = lambda: (settings.DATE_FORMAT, settings.DATETIME_FORMAT, settings.TIME_FORMAT)
+get_partial_date_formats = lambda: (settings.YEAR_MONTH_FORMAT, settings.MONTH_DAY_FORMAT)
Index: django/utils/formats.py
===================================================================
--- django/utils/formats.py	(.../trunk)	(revision 0)
+++ django/utils/formats.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -0,0 +1,95 @@
+import decimal
+import datetime
+
+from django.conf import settings
+from django.utils.translation import get_language
+from django.utils.importlib import import_module
+from django.utils import dateformat
+from django.utils import numberformat 
+
+def project_formats_module():
+    """
+    Returns the formats module for the current locale, defined
+    on the project
+    """
+    if settings.FORMAT_MODULE_PATH:
+        try:
+            return import_module('.formats', '%s.%s' % (settings.FORMAT_MODULE_PATH, get_language()))
+        except ImportError:
+            pass
+    return None
+
+def django_formats_module():
+    """
+    Returns the formats module for the current locale, defined
+    on Django
+    """
+    try:
+        return import_module('.formats', 'django.conf.locale.%s' % get_language())
+    except ImportError:
+        return None
+
+def getformat(format_type):
+    """
+    For a specific format type, returns the format for the
+    current language (locale) defaulting to the format on settings.
+    format_type is the name of the format, for example 'DATE_FORMAT'
+    """
+    if settings.USE_I18N and settings.USE_FORMAT_I18N:
+        for module in (project_formats_module(), django_formats_module()):
+            if module:
+                try:
+                    return getattr(module, format_type)
+                except AttributeError:
+                    pass
+    return getattr(settings, format_type)
+
+def date_format(value, format=None):
+    """
+    Formats a datetime.date or datetime.datetime object using a
+    localizable format
+    """
+    return dateformat.format(value, getformat(format or 'DATE_FORMAT'))
+
+def number_format(value, decimal_pos=None):
+    """
+    Formats a numeric value using localization settings
+    """
+    return numberformat.format(
+        value,
+        getformat('DECIMAL_SEPARATOR'),
+        decimal_pos,
+        getformat('NUMBER_GROUPING'),
+        getformat('THOUSAND_SEPARATOR'),
+    )
+
+def localize(value, is_input=False):
+    """
+    Checks value, and if it has a localizable type (date,
+    number...) it returns the value as a string using
+    current locale format
+    """
+    if settings.USE_I18N and settings.USE_FORMAT_I18N:
+        if isinstance(value, decimal.Decimal):
+            return number_format(value)
+        elif isinstance(value, float):
+            return number_format(value)
+        elif isinstance(value, int):
+            return number_format(value)
+        elif isinstance(value, datetime.datetime):
+            if not is_input:
+                return date_format(value, 'DATETIME_FORMAT')
+            else:
+                return value.strftime(getformat('DATETIME_INPUT_FORMATS')[0])
+        elif isinstance(value, datetime.date):
+            if not is_input:
+                return date_format(value)
+            else:
+                return value.strftime(getformat('DATE_INPUT_FORMATS')[0])
+        elif isinstance(value, datetime.time):
+            if not is_input:
+                return date_format(value, 'TIME_FORMAT')
+            else:
+                return value.strftime(getformat('TIME_INPUT_FORMATS')[0])
+    return value
+
Index: django/contrib/admin/media/js/calendar.js
===================================================================
--- django/contrib/admin/media/js/calendar.js	(.../trunk)	(revision 11464)
+++ django/contrib/admin/media/js/calendar.js	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -25,6 +25,7 @@
 var CalendarNamespace = {
     monthsOfYear: gettext('January February March April May June July August September October November December').split(' '),
     daysOfWeek: gettext('S M T W T F S').split(' '),
+    firstDayOfWeek: parseInt(gettext('FIRST_DAY_OF_WEEK')),
     isLeapYear: function(year) {
         return (((year % 4)==0) && ((year % 100)!=0) || ((year % 400)==0));
     },
@@ -56,10 +57,10 @@
         // Draw days-of-week header
         var tableRow = quickElement('tr', tableBody);
         for (var i = 0; i < 7; i++) {
-            quickElement('th', tableRow, CalendarNamespace.daysOfWeek[i]);
+            quickElement('th', tableRow, CalendarNamespace.daysOfWeek[(i + CalendarNamespace.firstDayOfWeek) % 7]);
         }
 
-        var startingPos = new Date(year, month-1, 1).getDay();
+        var startingPos = new Date(year, month-1, 1 - CalendarNamespace.firstDayOfWeek).getDay();
         var days = CalendarNamespace.getDaysInMonth(month, year);
 
         // Draw blanks before first of month
Index: django/contrib/admin/templatetags/admin_list.py
===================================================================
--- django/contrib/admin/templatetags/admin_list.py	(.../trunk)	(revision 11464)
+++ django/contrib/admin/templatetags/admin_list.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -3,11 +3,11 @@
 from django.contrib.admin.views.main import ORDER_VAR, ORDER_TYPE_VAR, PAGE_VAR, SEARCH_VAR
 from django.core.exceptions import ObjectDoesNotExist
 from django.db import models
-from django.utils import dateformat
+from django.utils import formats
 from django.utils.html import escape, conditional_escape
 from django.utils.text import capfirst
 from django.utils.safestring import mark_safe
-from django.utils.translation import get_date_formats, get_partial_date_formats, ugettext as _
+from django.utils.translation import ugettext as _
 from django.utils.encoding import smart_unicode, smart_str, force_unicode
 from django.template import Library
 import datetime
@@ -184,25 +184,24 @@
             # Dates and times are special: They're formatted in a certain way.
             elif isinstance(f, models.DateField) or isinstance(f, models.TimeField):
                 if field_val:
-                    (date_format, datetime_format, time_format) = get_date_formats()
-                    if isinstance(f, models.DateTimeField):
-                        result_repr = capfirst(dateformat.format(field_val, datetime_format))
-                    elif isinstance(f, models.TimeField):
-                        result_repr = capfirst(dateformat.time_format(field_val, time_format))
-                    else:
-                        result_repr = capfirst(dateformat.format(field_val, date_format))
+                    result_repr = formats.localize(field_val)
                 else:
                     result_repr = EMPTY_CHANGELIST_VALUE
+            elif isinstance(f, models.DecimalField):
+                if field_val:
+                    result_repr = formats.number_format(field_val, f.decimal_places)
+                else:
+                    result_repr = EMPTY_CHANGELIST_VALUE
                 row_class = ' class="nowrap"'
+            elif isinstance(f, models.FloatField):
+                if field_val:
+                    result_repr = formats.number_format(field_val)
+                else:
+                    result_repr = EMPTY_CHANGELIST_VALUE
+                row_class = ' class="nowrap"'
             # Booleans are special: We use images.
             elif isinstance(f, models.BooleanField) or isinstance(f, models.NullBooleanField):
                 result_repr = _boolean_icon(field_val)
-            # DecimalFields are special: Zero-pad the decimals.
-            elif isinstance(f, models.DecimalField):
-                if field_val is not None:
-                    result_repr = ('%%.%sf' % f.decimal_places) % field_val
-                else:
-                    result_repr = EMPTY_CHANGELIST_VALUE
             # Fields with choices are special: Use the representation
             # of the choice.
             elif f.flatchoices:
@@ -263,7 +262,6 @@
         year_lookup = cl.params.get(year_field)
         month_lookup = cl.params.get(month_field)
         day_lookup = cl.params.get(day_field)
-        year_month_format, month_day_format = get_partial_date_formats()
 
         link = lambda d: mark_safe(cl.get_query_string(d, [field_generic]))
 
@@ -273,9 +271,9 @@
                 'show': True,
                 'back': {
                     'link': link({year_field: year_lookup, month_field: month_lookup}),
-                    'title': dateformat.format(day, year_month_format)
+                    'title': capfirst(formats.date_format(day, 'YEAR_MONTH_FORMAT'))
                 },
-                'choices': [{'title': dateformat.format(day, month_day_format)}]
+                'choices': [{'title': capfirst(formats.date_format(day, 'MONTH_DAY_FORMAT'))}]
             }
         elif year_lookup and month_lookup:
             days = cl.query_set.filter(**{year_field: year_lookup, month_field: month_lookup}).dates(field_name, 'day')
@@ -287,7 +285,7 @@
                 },
                 'choices': [{
                     'link': link({year_field: year_lookup, month_field: month_lookup, day_field: day.day}),
-                    'title': dateformat.format(day, month_day_format)
+                    'title': capfirst(formats.date_format(day, 'MONTH_DAY_FORMAT'))
                 } for day in days]
             }
         elif year_lookup:
@@ -300,7 +298,7 @@
                 },
                 'choices': [{
                     'link': link({year_field: year_lookup, month_field: month.month}),
-                    'title': dateformat.format(month, year_month_format)
+                    'title': capfirst(formats.date_format(month, 'YEAR_MONTH_FORMAT'))
                 } for month in months]
             }
         else:
Index: django/contrib/databrowse/datastructures.py
===================================================================
--- django/contrib/databrowse/datastructures.py	(.../trunk)	(revision 11464)
+++ django/contrib/databrowse/datastructures.py	(.../branches/soc2009/i18n-improvements)	(revision 11464)
@@ -4,9 +4,8 @@
 """
 
 from django.db import models
-from django.utils import dateformat
+from django.utils import formats
 from django.utils.text import capfirst
-from django.utils.translation import get_date_formats
 from django.utils.encoding import smart_unicode, smart_str, iri_to_uri
 from django.utils.safestring import mark_safe
 from django.db.models.query import QuerySet
@@ -156,13 +155,12 @@
             objs = dict(self.field.choices).get(self.raw_value, EMPTY_VALUE)
         elif isinstance(self.field, models.DateField) or isinstance(self.field, models.TimeField):
             if self.raw_value:
-                date_format, datetime_format, time_format = get_date_formats()
                 if isinstance(self.field, models.DateTimeField):
-                    objs = capfirst(dateformat.format(self.raw_value, datetime_format))
+                    objs = capfirst(formats.date_format(self.raw_value, 'DATETIME_FORMAT'))
                 elif isinstance(self.field, models.TimeField):
-                    objs = capfirst(dateformat.time_format(self.raw_value, time_format))
+                    objs = capfirst(formats.date_format(self.raw_value, 'TIME_FORMAT'))
                 else:
-                    objs = capfirst(dateformat.format(self.raw_value, date_format))
+                    objs = capfirst(formats.date_format(self.raw_value, 'DATE_FORMAT'))
             else:
                 objs = EMPTY_VALUE
         elif isinstance(self.field, models.BooleanField) or isinstance(self.field, models.NullBooleanField):
